diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/character.cpp alien-rc4/src//game/server/entities/character.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/character.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/character.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -4,10 +4,13 @@
 #include <engine/shared/config.h>
 #include <game/server/gamecontext.h>
 #include <game/mapitems.h>
+#include <game/server/gamemodes/mod.h>
 
 #include "character.h"
 #include "laser.h"
+#include "laserwall.h"
 #include "projectile.h"
+#include "singularinator.h"
 
 //input count
 struct CInputCount
@@ -45,6 +48,10 @@ CCharacter::CCharacter(CGameWorld *pWorl
 	m_ProximityRadius = ms_PhysSize;
 	m_Health = 0;
 	m_Armor = 0;
+
+	// Mutator
+	m_LaserWall = 0;
+	m_QueuedLaser = LASER_SUBTYPE_NORMAL;	
 }
 
 void CCharacter::Reset()
@@ -62,7 +69,7 @@ bool CCharacter::Spawn(CPlayer *pPlayer,
 
 	m_pPlayer = pPlayer;
 	m_Pos = Pos;
-
+	
 	m_Core.Reset();
 	m_Core.Init(&GameServer()->m_World.m_Core, GameServer()->Collision());
 	m_Core.m_Pos = m_Pos;
@@ -75,11 +82,99 @@ bool CCharacter::Spawn(CPlayer *pPlayer,
 	GameServer()->m_World.InsertEntity(this);
 	m_Alive = true;
 
-	GameServer()->m_pController->OnCharacterSpawn(this);
+	// No nead for next line ... we had to change too much stuff already here anyway ... 
+	// GameServer()->m_pController->OnCharacterSpawn(this);
 
+	// Mutator
+	
+	// Init Eyes
+	m_MutanticEmoteTick = Server()->Tick() + 500 * Server()->TickSpeed() / 1000;
+	if(GetPlayer()->m_MutatorTeam > TEAM_REAPER)
+		SetEmote(EMOTE_NORMAL,-1);
+	else
+		SetEmote(EMOTE_ANGRY,m_MutanticEmoteTick);
+	
+	m_MutanticEyeOn = 0;
+
+	// Default settings of health and hammer	
+	IncreaseHealth(10);
+	GiveWeapon(WEAPON_HAMMER, -1);
+
+	// Laser Subtype stuff
+	m_QueuedLaser = LASER_SUBTYPE_NORMAL;
+	m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo = 0;
+	m_aWeapons[WEAPON_RIFLE].m_NormalAmmo = 0;
+	m_LaserCycleInfoSwitch = 0;
+	mem_zero(&m_OwnLaserSubType,sizeof(m_OwnLaserSubType));
+	m_OwnLaserSubType[0] = true; // always own knowledge of normal laser :)
+	if(m_pPlayer->m_ScienceExplored&SCIENCE_LASER_RIDDLE)
+		m_OwnLaserSubType[1] = true;
+	if(m_pPlayer->m_ScienceExplored&SCIENCE_LASER_TELE)
+		m_OwnLaserSubType[2] = true;
+	if(m_pPlayer->m_ScienceExplored&SCIENCE_LASER_HEALING)
+		m_OwnLaserSubType[3] = true;
+
+	// On tile or entity switches
+	m_OnTurret = 0;
+	m_PrevOnTurret = 0;
+	m_TurretAmmo = 0;
+	m_TurretActive = 0;
+	m_OnScience = 0;
+	m_PrevOnScience = 0;
+	m_Invisible = 0;
+	m_OnEnergyUp = 0;
+	m_PrevOnEnergyUp = 0;
+	m_OnReapinator = 0;
+	m_PrevOnReapinator = 0;
+
+	m_pPlayer->m_MultiScore = 0;
+
+	// Timer
+	m_BioHazardDamageTick = Server()->Tick();
+	m_pPlayer->m_MultiScoreTick = Server()->Tick();
+	m_ShowInfoTick = Server()->Tick();
+	m_EnergyUpTick = Server()->Tick();
+	
+	
+	// Multijump
+	m_MutanticArmorDJCount = 0;
+
+	// Owner of airstrike
+	m_OwnAirstrike = 0;
+
+	// Set right team depending on gamestatus 
+	if(GameServer()->m_pController->MutGameRunning() == 0)
+		m_pPlayer->m_MutatorTeam = TEAM_HUMAN;
+	else if(m_pPlayer->m_MutatorTeam >= TEAM_HUMAN)
+		m_pPlayer->m_MutatorTeam = TEAM_MUTANT;
+
+	// Give weapons depending on team
+	if(m_pPlayer->m_MutatorTeam <= TEAM_MUTANT)
+	{
+		SetWeapon(WEAPON_HAMMER);
+		m_MutanticSpawnProtection = Server()->Tick() + 1000 * Server()->TickSpeed() / 1000;;
+		if(m_pPlayer->m_MutaticLevels&MUTATOR_START_SHIELDS)
+			IncreaseArmor(10);
+	}
+	else if(m_pPlayer->m_MutatorTeam < TEAM_HERO)
+	{
+		GiveWeapon(WEAPON_GUN, 10);
+		SetWeapon(WEAPON_GUN);
+	}
+	else
+	{	
+		GiveWeapon(WEAPON_GUN, 5);
+		GiveWeapon(WEAPON_SHOTGUN, 10);
+		SetWeapon(WEAPON_SHOTGUN);
+	}
 	return true;
 }
 
+void CCharacter::SetPreStartGame()
+{
+	m_MutanticEmoteTick = Server()->Tick();
+}
+
 void CCharacter::Destroy()
 {
 	GameServer()->m_World.m_Core.m_apCharacters[m_pPlayer->GetCID()] = 0;
@@ -109,7 +204,6 @@ bool CCharacter::IsGrounded()
 	return false;
 }
 
-
 void CCharacter::HandleNinja()
 {
 	if(m_ActiveWeapon != WEAPON_NINJA)
@@ -193,11 +287,58 @@ void CCharacter::HandleNinja()
 void CCharacter::DoWeaponSwitch()
 {
 	// make sure we can switch
-	if(m_ReloadTimer != 0 || m_QueuedWeapon == -1 || m_aWeapons[WEAPON_NINJA].m_Got)
+	if(m_ReloadTimer != 0 || m_QueuedWeapon == -1 || m_aWeapons[WEAPON_NINJA].m_Got || m_pPlayer->m_MutatorTeam == TEAM_MUTANT 
+				|| (m_pPlayer->m_MutatorTeam == TEAM_REAPER && !(m_QueuedWeapon == WEAPON_HAMMER || m_QueuedWeapon == WEAPON_RIFLE)) || m_OnTurret)
 		return;
 
+	// Backup Ammo state if laser (healing laser is different ammo)
+	if(m_ActiveWeapon == WEAPON_RIFLE)
+	{
+		if(m_aWeapons[WEAPON_RIFLE].m_SubType == LASER_SUBTYPE_HEALING)
+			m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo = m_aWeapons[WEAPON_RIFLE].m_Ammo;
+
+		else
+			m_aWeapons[WEAPON_RIFLE].m_NormalAmmo = m_aWeapons[WEAPON_RIFLE].m_Ammo;
+	}
+
 	// switch Weapon
 	SetWeapon(m_QueuedWeapon);
+
+	// Handle LaserSubtype Ammo and Broadcast-info-timer
+	if(m_ActiveWeapon == WEAPON_RIFLE && m_pPlayer->m_MutatorTeam >= TEAM_HUMAN)
+	{
+		if(m_aWeapons[WEAPON_RIFLE].m_SubType == LASER_SUBTYPE_HEALING)
+		{
+			// Drop HEALING_LASER from cycle if no ammo is available anymore
+			if(m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo < 1 || m_OwnLaserSubType[LASER_SUBTYPE_HEALING] == false)
+			{
+				m_OwnLaserSubType[LASER_SUBTYPE_HEALING] = false;
+				m_aWeapons[WEAPON_RIFLE].m_SubType = LASER_SUBTYPE_NORMAL;
+			}
+		}
+
+		// Use better riddle-laser if available
+		if(m_aWeapons[WEAPON_RIFLE].m_SubType == LASER_SUBTYPE_NORMAL && m_OwnLaserSubType[LASER_SUBTYPE_RIDDLE])
+			m_aWeapons[WEAPON_RIFLE].m_SubType = LASER_SUBTYPE_RIDDLE;
+
+		// Just inform if some special type was choosen
+		if(m_aWeapons[WEAPON_RIFLE].m_SubType != LASER_SUBTYPE_NORMAL)
+		{
+			m_LaserCycleTick = Server()->Tick() + 250 * Server()->TickSpeed() / 1000; // Avoid flood at fast cycling (just inform if he keep it)
+			m_LaserCycleInfoSwitch = 1;
+		}
+		
+		// Use right ammo-type
+		switch(m_aWeapons[WEAPON_RIFLE].m_SubType)
+		{
+			case LASER_SUBTYPE_NORMAL:
+			case LASER_SUBTYPE_RIDDLE:
+			case LASER_SUBTYPE_TELE:
+				m_aWeapons[WEAPON_RIFLE].m_Ammo = m_aWeapons[WEAPON_RIFLE].m_NormalAmmo; break;
+			case LASER_SUBTYPE_HEALING:
+				m_aWeapons[WEAPON_RIFLE].m_Ammo = m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo; break; 
+		}
+	}
 }
 
 void CCharacter::HandleWeaponSwitch()
@@ -205,7 +346,7 @@ void CCharacter::HandleWeaponSwitch()
 	int WantedWeapon = m_ActiveWeapon;
 	if(m_QueuedWeapon != -1)
 		WantedWeapon = m_QueuedWeapon;
-
+	
 	// select Weapon
 	int Next = CountInput(m_LatestPrevInput.m_NextWeapon, m_LatestInput.m_NextWeapon).m_Presses;
 	int Prev = CountInput(m_LatestPrevInput.m_PrevWeapon, m_LatestInput.m_PrevWeapon).m_Presses;
@@ -231,16 +372,94 @@ void CCharacter::HandleWeaponSwitch()
 	}
 
 	// Direct Weapon selection
-	if(m_LatestInput.m_WantedWeapon)
+	if(m_LatestInput.m_WantedWeapon > 0)
 		WantedWeapon = m_Input.m_WantedWeapon-1;
 
-	// check for insane values
 	if(WantedWeapon >= 0 && WantedWeapon < NUM_WEAPONS && WantedWeapon != m_ActiveWeapon && m_aWeapons[WantedWeapon].m_Got)
 		m_QueuedWeapon = WantedWeapon;
 
 	DoWeaponSwitch();
 }
 
+void CCharacter::CycleLaserSubTypes()
+{
+	if(m_pPlayer->m_MutatorTeam <= TEAM_MUTANT || !m_aWeapons[WEAPON_RIFLE].m_Got)
+		return;
+
+	int ActiveLaser = m_aWeapons[WEAPON_RIFLE].m_SubType;
+
+	// Drop Healing-Laser if not available anymore
+	if(m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo == 0)
+		m_OwnLaserSubType[LASER_SUBTYPE_HEALING] = false;
+
+	for(int i = 0; i < LASER_MAX_SUBTYPE; i++)
+	{
+		m_QueuedLaser = ++m_QueuedLaser%LASER_MAX_SUBTYPE;
+		
+		if(m_QueuedLaser == LASER_SUBTYPE_NORMAL && m_OwnLaserSubType[LASER_SUBTYPE_RIDDLE])
+			m_QueuedLaser = LASER_SUBTYPE_RIDDLE;
+
+		if(m_OwnLaserSubType[m_QueuedLaser])
+			break;
+	}
+		
+	if(ActiveLaser == m_QueuedLaser)
+		return;
+	else
+	{
+		if(ActiveLaser == LASER_SUBTYPE_HEALING)
+                        m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo = m_aWeapons[WEAPON_RIFLE].m_Ammo;
+		else
+			m_aWeapons[WEAPON_RIFLE].m_NormalAmmo = m_aWeapons[WEAPON_RIFLE].m_Ammo;
+		
+		m_aWeapons[WEAPON_RIFLE].m_SubType = m_QueuedLaser;
+	}
+
+	if(m_ActiveWeapon == WEAPON_RIFLE)
+		SetWeapon(WEAPON_HAMMER);
+
+	m_QueuedWeapon = WEAPON_RIFLE;
+	DoWeaponSwitch();
+}
+
+void CCharacter::AirStrike()
+{
+	if(!m_OwnAirstrike)
+	{
+		GameServer()->SendChatTarget(m_pPlayer->GetCID(),"No airstrike available.");
+		return;
+	}
+	else if(m_pPlayer->m_MutatorTeam <= TEAM_MUTANT)
+	{
+		GameServer()->SendChatTarget(m_pPlayer->GetCID(),"Mutants don't need airstrikes.");
+		return;
+	}
+	
+	m_OwnAirstrike--;
+
+	vec2 pStrikeDir = normalize(vec2(m_LatestInput.m_TargetX, m_LatestInput.m_TargetY)); 
+        for(int bomb = -320; bomb < (GameServer()->Collision()->GetWidth()+10)*32; bomb += g_Config.m_SvHumAirStrikeStep)
+        {
+		CProjectile *pProj = new CProjectile(GameWorld(), WEAPON_GRENADE,
+			m_pPlayer->GetCID(),
+			vec2(bomb,0),
+			pStrikeDir,
+			g_Config.m_SvAirStrikeTTL,
+			1, true, 0, SOUND_GRENADE_EXPLODE, WEAPON_GRENADE,
+			g_Config.m_SvAirStrikeClusters, WEAPON_GRENADE, Server()->TickSpeed()*GameServer()->Tuning()->m_GrenadeLifetime, 1, 1, 0, SOUND_GRENADE_EXPLODE);
+
+		// pack the Projectile and send it to the client Directly
+		CNetObj_Projectile p;
+		pProj->FillInfo(&p);
+
+		CMsgPacker Msg(NETMSGTYPE_SV_EXTRAPROJECTILE);
+		Msg.AddInt(1);
+		for(unsigned i = 0; i < sizeof(CNetObj_Projectile)/sizeof(int); i++)
+			Msg.AddInt(((int *)&p)[i]);
+		Server()->SendMsg(&Msg, 0, m_pPlayer->GetCID());
+        }
+}
+
 void CCharacter::FireWeapon()
 {
 	if(m_ReloadTimer != 0)
@@ -250,10 +469,9 @@ void CCharacter::FireWeapon()
 	vec2 Direction = normalize(vec2(m_LatestInput.m_TargetX, m_LatestInput.m_TargetY));
 
 	bool FullAuto = false;
-	if(m_ActiveWeapon == WEAPON_GRENADE || m_ActiveWeapon == WEAPON_SHOTGUN || m_ActiveWeapon == WEAPON_RIFLE)
+	if(m_ActiveWeapon == WEAPON_GRENADE || m_ActiveWeapon == WEAPON_SHOTGUN || m_ActiveWeapon == WEAPON_RIFLE || m_TurretActive)
 		FullAuto = true;
 
-
 	// check if we gonna fire
 	bool WillFire = false;
 	if(CountInput(m_LatestPrevInput.m_Fire, m_LatestInput.m_Fire).m_Presses)
@@ -280,6 +498,25 @@ void CCharacter::FireWeapon()
 	{
 		case WEAPON_HAMMER:
 		{
+			// Create laserwall if human and not on Science station
+			if(m_pPlayer->m_MutatorTeam >= TEAM_HUMAN)
+			{
+				if(!m_OnScience && !m_OnEnergyUp)
+				{
+					if(m_LaserWall)
+					{
+						DestroyLaserWall();
+						GameServer()->CreateSound(m_Pos, SOUND_RIFLE_BOUNCE);
+					}
+					else if(m_Armor > 0)
+					{
+						DecreaseArmor(1);
+						m_LaserWall = new CLaserWall(GameWorld(), m_Pos, Direction, g_Config.m_SvLaserWallLength ,m_pPlayer->GetCID());
+						GameServer()->CreateSound(m_Pos, SOUND_WEAPON_NOAMMO);
+					}
+				}
+			}
+
 			// reset objects Hit
 			m_NumObjectsHit = 0;
 			GameServer()->CreateSound(m_Pos, SOUND_HAMMER_FIRE);
@@ -321,31 +558,96 @@ void CCharacter::FireWeapon()
 
 		case WEAPON_GUN:
 		{
-			CProjectile *pProj = new CProjectile(GameWorld(), WEAPON_GUN,
-				m_pPlayer->GetCID(),
-				ProjStartPos,
-				Direction,
-				(int)(Server()->TickSpeed()*GameServer()->Tuning()->m_GunLifetime),
-				1, 0, 0, -1, WEAPON_GUN);
-
-			// pack the Projectile and send it to the client Directly
-			CNetObj_Projectile p;
-			pProj->FillInfo(&p);
-
-			CMsgPacker Msg(NETMSGTYPE_SV_EXTRAPROJECTILE);
-			Msg.AddInt(1);
-			for(unsigned i = 0; i < sizeof(CNetObj_Projectile)/sizeof(int); i++)
-				Msg.AddInt(((int *)&p)[i]);
-
-			Server()->SendMsg(&Msg, 0, m_pPlayer->GetCID());
-
-			GameServer()->CreateSound(m_Pos, SOUND_GUN_FIRE);
+			switch(m_TurretActive)
+			{
+				// normal gun behavior
+				case 0:
+				{
+					CProjectile *pProj;
+					if(m_pPlayer->m_ScienceExplored&SCIENCE_GUN_MK2)
+					{
+						pProj = new CProjectile(GameWorld(), WEAPON_GUN,
+							m_pPlayer->GetCID(),
+							ProjStartPos,
+							Direction,
+							(int)(Server()->TickSpeed()*GameServer()->Tuning()->m_GunLifetime),
+							1, 0, float(g_Config.m_SvGunMK2Force), -1, WEAPON_GUN);
+					}
+					else
+					{
+						pProj = new CProjectile(GameWorld(), WEAPON_GUN,
+							m_pPlayer->GetCID(),
+							ProjStartPos,
+							Direction,
+							(int)(Server()->TickSpeed()*GameServer()->Tuning()->m_GunLifetime),
+							1, 0, 0, -1, WEAPON_GUN);
+					}
+						
+
+					// pack the Projectile and send it to the client Directly
+					CNetObj_Projectile p;
+					pProj->FillInfo(&p);
+
+					CMsgPacker Msg(NETMSGTYPE_SV_EXTRAPROJECTILE);
+					Msg.AddInt(1);
+					for(unsigned i = 0; i < sizeof(CNetObj_Projectile)/sizeof(int); i++)
+						Msg.AddInt(((int *)&p)[i]);
+	
+					Server()->SendMsg(&Msg, 0, m_pPlayer->GetCID());
+
+					GameServer()->CreateSound(m_Pos, SOUND_GUN_FIRE);
+				} break;
+				// Fire turret
+				case 1:
+				{
+					CProjectile *pProj = new CProjectile(GameWorld(), WEAPON_SHOTGUN,
+						m_pPlayer->GetCID(),
+						ProjStartPos,
+						Direction,
+						(int)(Server()->TickSpeed()*GameServer()->Tuning()->m_GunLifetime),
+						g_Config.m_SvSGTurretNonExpDmg, 1, 2.f, SOUND_GRENADE_EXPLODE, WEAPON_SHOTGUN);
+
+					// pack the Projectile and send it to the client Directly
+					CNetObj_Projectile p;
+					pProj->FillInfo(&p);
+
+					CMsgPacker Msg(NETMSGTYPE_SV_EXTRAPROJECTILE);
+					Msg.AddInt(1);
+					for(unsigned i = 0; i < sizeof(CNetObj_Projectile)/sizeof(int); i++)
+						Msg.AddInt(((int *)&p)[i]);
+
+					Server()->SendMsg(&Msg, 0, m_pPlayer->GetCID());
+
+					GameServer()->CreateSound(m_Pos, SOUND_SHOTGUN_FIRE);
+					GameServer()->CreateSound(m_Pos, SOUND_WEAPON_NOAMMO);
+					GameServer()->CreateSound(m_Pos, SOUND_RIFLE_FIRE);
+				} break;
+			}
 		} break;
 
 		case WEAPON_SHOTGUN:
 		{
 			int ShotSpread = 2;
+			float HeroBonus;
+			int DoExplode;
+			int ExplodeSound;
 
+			if(m_pPlayer->m_MutatorTeam == TEAM_HERO || m_pPlayer->m_ScienceExplored&SCIENCE_SHOTGUN_FORCEX2)
+				HeroBonus = float(g_Config.m_SvShotMK2Force);
+			else
+				HeroBonus = 0;
+
+			if(m_pPlayer->m_ScienceExplored&SCIENCE_SHOTGUN_EXPL)
+			{
+				DoExplode = 1;
+				ExplodeSound = SOUND_GRENADE_EXPLODE;
+			}
+			else
+			{
+				DoExplode = 0;
+				ExplodeSound = -1;
+			}
+				
 			CMsgPacker Msg(NETMSGTYPE_SV_EXTRAPROJECTILE);
 			Msg.AddInt(ShotSpread*2+1);
 
@@ -361,7 +663,7 @@ void CCharacter::FireWeapon()
 					ProjStartPos,
 					vec2(cosf(a), sinf(a))*Speed,
 					(int)(Server()->TickSpeed()*GameServer()->Tuning()->m_ShotgunLifetime),
-					1, 0, 0, -1, WEAPON_SHOTGUN);
+					1, DoExplode, HeroBonus, ExplodeSound, WEAPON_SHOTGUN);
 
 				// pack the Projectile and send it to the client Directly
 				CNetObj_Projectile p;
@@ -378,13 +680,29 @@ void CCharacter::FireWeapon()
 
 		case WEAPON_GRENADE:
 		{
-			CProjectile *pProj = new CProjectile(GameWorld(), WEAPON_GRENADE,
-				m_pPlayer->GetCID(),
-				ProjStartPos,
-				Direction,
-				(int)(Server()->TickSpeed()*GameServer()->Tuning()->m_GrenadeLifetime),
-				1, true, 0, SOUND_GRENADE_EXPLODE, WEAPON_GRENADE);
-
+			CProjectile *pProj;
+			// Clusterbombs
+			if(m_pPlayer->m_ScienceExplored&SCIENCE_GRENADE_CLUSTER)
+			{
+				pProj = new CProjectile(GameWorld(), WEAPON_GRENADE,
+					m_pPlayer->GetCID(),
+					ProjStartPos,
+					Direction,
+					(int)(Server()->TickSpeed()*GameServer()->Tuning()->m_GrenadeLifetime),
+					1, true, 0, SOUND_GRENADE_EXPLODE, WEAPON_GRENADE,
+					g_Config.m_SvClusters, WEAPON_GRENADE, Server()->TickSpeed()*GameServer()->Tuning()->m_GrenadeLifetime, 1, 1, 0, SOUND_GRENADE_EXPLODE);
+			}
+			// Normal grenades
+			else
+			{
+				pProj = new CProjectile(GameWorld(), WEAPON_GRENADE,
+					m_pPlayer->GetCID(),
+					ProjStartPos,
+					Direction,
+					(int)(Server()->TickSpeed()*GameServer()->Tuning()->m_GrenadeLifetime),
+					1, true, 0, SOUND_GRENADE_EXPLODE, WEAPON_GRENADE);
+			}
+				
 			// pack the Projectile and send it to the client Directly
 			CNetObj_Projectile p;
 			pProj->FillInfo(&p);
@@ -400,8 +718,27 @@ void CCharacter::FireWeapon()
 
 		case WEAPON_RIFLE:
 		{
-			new CLaser(GameWorld(), m_Pos, Direction, GameServer()->Tuning()->m_LaserReach, m_pPlayer->GetCID());
-			GameServer()->CreateSound(m_Pos, SOUND_RIFLE_FIRE);
+			if(m_pPlayer->m_MutatorTeam == TEAM_REAPER)
+			// Black hole weapon
+			{
+				new CSingularinator(GameWorld(), m_Pos, Direction, GameServer()->Tuning()->m_LaserReach, m_pPlayer->GetCID(), Server()->Tick() + g_Config.m_SvSingularinatorTTL * Server()->TickSpeed());
+				GameServer()->CreateSound(m_Pos, SOUND_RIFLE_FIRE);
+				GameServer()->CreateSound(m_Pos, SOUND_SHOTGUN_FIRE);
+			}
+			else
+			// Human lasers
+			{
+				new CLaser(GameWorld(), m_Pos, Direction, GameServer()->Tuning()->m_LaserReach, m_pPlayer->GetCID(), m_aWeapons[WEAPON_RIFLE].m_SubType);
+				GameServer()->CreateSound(m_Pos, SOUND_RIFLE_FIRE);
+				if(m_aWeapons[WEAPON_RIFLE].m_SubType == LASER_SUBTYPE_HEALING)
+				{
+					m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo--;
+					if(m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo < 1)
+						m_OwnLaserSubType[LASER_SUBTYPE_HEALING] = 0;
+				}
+				else
+					m_aWeapons[WEAPON_RIFLE].m_NormalAmmo--;
+			}
 		} break;
 
 		case WEAPON_NINJA:
@@ -419,11 +756,18 @@ void CCharacter::FireWeapon()
 	}
 
 	m_AttackTick = Server()->Tick();
+	m_aWeapons[m_ActiveWeapon].m_Ammo--;
 
-	if(m_aWeapons[m_ActiveWeapon].m_Ammo > 0) // -1 == unlimited
-		m_aWeapons[m_ActiveWeapon].m_Ammo--;
-
-	if(!m_ReloadTimer)
+	if(m_pPlayer->m_MutatorTeam >= TEAM_HUMAN)
+	{
+		if(m_TurretActive) // use slower reload time for Turret 
+			m_ReloadTimer = Server()->TickSpeed()/10;
+		else if(m_pPlayer->m_ScienceExplored&SCIENCE_SHOTGUN_FASTRELOAD && m_ActiveWeapon == WEAPON_SHOTGUN)
+			m_ReloadTimer = (g_pData->m_Weapons.m_aId[m_ActiveWeapon].m_Firedelay/2) * Server()->TickSpeed() / 1000;
+		else if(!m_ReloadTimer)
+			m_ReloadTimer = g_pData->m_Weapons.m_aId[m_ActiveWeapon].m_Firedelay * Server()->TickSpeed() / 1000;
+	}
+	else if(!m_ReloadTimer)
 		m_ReloadTimer = g_pData->m_Weapons.m_aId[m_ActiveWeapon].m_Firedelay * Server()->TickSpeed() / 1000;
 }
 
@@ -443,6 +787,9 @@ void CCharacter::HandleWeapons()
 	FireWeapon();
 
 	// ammo regen
+	if(m_TurretActive)
+		return;
+
 	int AmmoRegenTime = g_pData->m_Weapons.m_aId[m_ActiveWeapon].m_Ammoregentime;
 	if(AmmoRegenTime)
 	{
@@ -468,9 +815,31 @@ void CCharacter::HandleWeapons()
 	return;
 }
 
-bool CCharacter::GiveWeapon(int Weapon, int Ammo)
+bool CCharacter::GiveWeapon(int Weapon, int Ammo, int Special)
 {
-	if(m_aWeapons[Weapon].m_Ammo < g_pData->m_Weapons.m_aId[Weapon].m_Maxammo || !m_aWeapons[Weapon].m_Got)
+	if(Weapon == WEAPON_RIFLE)
+	{
+		if(Special == 1)
+		{
+			if(m_aWeapons[Weapon].m_SpecialAmmo < g_pData->m_Weapons.m_aId[Weapon].m_Maxammo)
+			{
+				m_aWeapons[Weapon].m_Got = true;
+				m_aWeapons[Weapon].m_SpecialAmmo = min(g_pData->m_Weapons.m_aId[Weapon].m_Maxammo, Ammo);
+				if(m_ActiveWeapon == WEAPON_RIFLE && m_aWeapons[WEAPON_RIFLE].m_SubType == LASER_SUBTYPE_HEALING)
+					m_aWeapons[WEAPON_RIFLE].m_Ammo = m_aWeapons[WEAPON_RIFLE].m_SpecialAmmo;
+				return true;
+			}
+		}
+		else if(m_aWeapons[Weapon].m_NormalAmmo < g_pData->m_Weapons.m_aId[Weapon].m_Maxammo || !m_aWeapons[Weapon].m_Got)
+		{
+			m_aWeapons[Weapon].m_Got = true;
+			m_aWeapons[Weapon].m_NormalAmmo = min(g_pData->m_Weapons.m_aId[Weapon].m_Maxammo, Ammo);
+			if(m_ActiveWeapon == WEAPON_RIFLE && m_aWeapons[WEAPON_RIFLE].m_SubType != LASER_SUBTYPE_HEALING)
+				m_aWeapons[WEAPON_RIFLE].m_Ammo = m_aWeapons[WEAPON_RIFLE].m_NormalAmmo;
+			return true;
+		}
+	}
+	else if(m_aWeapons[Weapon].m_Ammo < g_pData->m_Weapons.m_aId[Weapon].m_Maxammo || !m_aWeapons[Weapon].m_Got)
 	{
 		m_aWeapons[Weapon].m_Got = true;
 		m_aWeapons[Weapon].m_Ammo = min(g_pData->m_Weapons.m_aId[Weapon].m_Maxammo, Ammo);
@@ -495,6 +864,15 @@ void CCharacter::SetEmote(int Emote, int
 {
 	m_EmoteType = Emote;
 	m_EmoteStop = Tick;
+	if(Emote == EMOTE_FLASHING)
+	{	
+		m_MutanticEyeOn = 1;
+	        m_MutanticEyeFlip = 1;
+		m_MutanticEyeFlipTick = Server()->Tick() + 250 * Server()->TickSpeed() / 1000;
+		m_EmoteType = EMOTE_NORMAL;
+	}	
+	else
+		m_MutanticEyeOn = 0;
 }
 
 void CCharacter::OnPredictedInput(CNetObj_PlayerInput *pNewInput)
@@ -517,6 +895,10 @@ void CCharacter::OnDirectInput(CNetObj_P
 	mem_copy(&m_LatestPrevInput, &m_LatestInput, sizeof(m_LatestInput));
 	mem_copy(&m_LatestInput, pNewInput, sizeof(m_LatestInput));
 
+        // it is not allowed to aim in the center
+	if(m_LatestInput.m_TargetX == 0 && m_LatestInput.m_TargetY == 0)
+		m_LatestInput.m_TargetY = -1;
+
 	if(m_NumInputs > 2 && m_pPlayer->GetTeam() != TEAM_SPECTATORS)
 	{
 		HandleWeaponSwitch();
@@ -540,33 +922,295 @@ void CCharacter::ResetInput()
 
 void CCharacter::Tick()
 {
-	if(m_pPlayer->m_ForceBalanced)
+	// useless for this mod
+	/*if(m_pPlayer->m_ForceBalanced)
 	{
 		char Buf[128];
 		str_format(Buf, sizeof(Buf), "You were moved to %s due to team balancing", GameServer()->m_pController->GetTeamName(m_pPlayer->GetTeam()));
 		GameServer()->SendBroadcast(Buf, m_pPlayer->GetCID());
 
 		m_pPlayer->m_ForceBalanced = false;
-	}
-
+	}*/
+	
+	// Get Input 	
 	m_Core.m_Input = m_Input;
 	m_Core.Tick(true);
 
+	// Reset to check again later
+	m_OnTurret = 0;
+	m_OnEnergyUp = 0;
+	m_OnReapinator = 0;
+	
+	// Get collisions
+	m_Col1 = GameServer()->Collision()->GetCollisionAt(m_Pos.x+m_ProximityRadius/3.f, m_Pos.y-m_ProximityRadius/3.f);
+	m_Col2 = GameServer()->Collision()->GetCollisionAt(m_Pos.x+m_ProximityRadius/3.f, m_Pos.y+m_ProximityRadius/3.f);
+	m_Col3 = GameServer()->Collision()->GetCollisionAt(m_Pos.x-m_ProximityRadius/3.f, m_Pos.y+m_ProximityRadius/3.f);
+	m_Col4 = GameServer()->Collision()->GetCollisionAt(m_Pos.x-m_ProximityRadius/3.f, m_Pos.y+m_ProximityRadius/3.f);
+
 	// handle death-tiles and leaving gamelayer
-	if(GameServer()->Collision()->GetCollisionAt(m_Pos.x+m_ProximityRadius/3.f, m_Pos.y-m_ProximityRadius/3.f)&CCollision::COLFLAG_DEATH ||
-		GameServer()->Collision()->GetCollisionAt(m_Pos.x+m_ProximityRadius/3.f, m_Pos.y+m_ProximityRadius/3.f)&CCollision::COLFLAG_DEATH ||
-		GameServer()->Collision()->GetCollisionAt(m_Pos.x-m_ProximityRadius/3.f, m_Pos.y-m_ProximityRadius/3.f)&CCollision::COLFLAG_DEATH ||
-		GameServer()->Collision()->GetCollisionAt(m_Pos.x-m_ProximityRadius/3.f, m_Pos.y+m_ProximityRadius/3.f)&CCollision::COLFLAG_DEATH ||
-		GameLayerClipped(m_Pos))
-	{
+	if(m_Col1&CCollision::COLFLAG_DEATH || m_Col2&CCollision::COLFLAG_DEATH || m_Col3&CCollision::COLFLAG_DEATH || m_Col4&CCollision::COLFLAG_DEATH 
+			|| GameLayerClipped(m_Pos))
 		Die(m_pPlayer->GetCID(), WEAPON_WORLD);
-	}
 
+	// handle invisible tiles
+	if(m_Col1&CCollision::COLFLAG_INVIS || m_Col2&CCollision::COLFLAG_INVIS || m_Col3&CCollision::COLFLAG_INVIS || m_Col4&CCollision::COLFLAG_INVIS)
+		m_Invisible = 1;
+	else
+		m_Invisible = 0;
+
+	if(m_Col1&CCollision::COLFLAG_BIOHAZARD || m_Col2&CCollision::COLFLAG_BIOHAZARD 
+			|| m_Col3&CCollision::COLFLAG_BIOHAZARD || m_Col4&CCollision::COLFLAG_BIOHAZARD)
+	{
+		if(m_pPlayer->m_MutatorTeam > TEAM_REAPER && !(m_pPlayer->m_MutatorTeam == TEAM_MUTANT && m_pPlayer->m_MutaticLevels&MUTATOR_NOBIOHAZARD))
+		{
+		        if(!m_MutanticEyeOn && Server()->Tick() - m_BioHazardDamageTick > 0)
+			{
+                		TakeMinorDamage();
+				GameServer()->CreateSound(m_Pos, SOUND_PLAYER_PAIN_SHORT);
+				m_BioHazardDamageTick = Server()->Tick() + 150 * Server()->TickSpeed() / 1000;
+				m_EmoteType = EMOTE_PAIN;
+				m_EmoteStop = Server()->Tick() + 500 * Server()->TickSpeed() / 1000;
+        		}	
+		}
+	}
+	else if(m_Col1&CCollision::COLFLAG_REAPER || m_Col2&CCollision::COLFLAG_REAPER
+			|| m_Col3&CCollision::COLFLAG_REAPER || m_Col4&CCollision::COLFLAG_REAPER)
+	{
+		m_OnReapinator = 1;
+	}
+	else if(m_Col1&CCollision::COLFLAG_ENERGYUP || m_Col2&CCollision::COLFLAG_ENERGYUP
+			|| m_Col3&CCollision::COLFLAG_ENERGYUP || m_Col4&CCollision::COLFLAG_ENERGYUP)
+	{
+		m_OnEnergyUp = 1;
+	}
+	// handle human only tiles
+	else if(m_pPlayer->m_MutatorTeam >= TEAM_HUMAN)
+	{
+		// set on turret switch
+		if(m_Col1&CCollision::COLFLAG_TURRET || m_Col2&CCollision::COLFLAG_TURRET 
+				|| m_Col3&CCollision::COLFLAG_TURRET || m_Col4&CCollision::COLFLAG_TURRET)
+			m_OnTurret = 1; 
+	}
+	
 	// handle Weapons
 	HandleWeapons();
 
+	// handle human stuff
+	if(m_pPlayer->m_MutatorTeam >= TEAM_HUMAN)
+	{
+		// OnScience Reset
+		if(m_OnScience && Server()->Tick() - m_OnScienceOffTick > 0)
+			m_OnScience = 0;
+
+		// turret 
+		if(m_OnTurret)
+		{
+			m_TurretActive = 1;
+			if(!m_PrevOnTurret)
+			{
+				m_LastWeapon = m_ActiveWeapon;
+				m_PrevTurretSwitchAmmo = m_aWeapons[WEAPON_GUN].m_Ammo;
+				m_PrevTurretSwitchGot = m_aWeapons[WEAPON_GUN].m_Got;
+				SetWeapon(WEAPON_GUN);
+				m_aWeapons[m_ActiveWeapon].m_Ammo = m_TurretAmmo;
+				m_aWeapons[m_ActiveWeapon].m_Got = true;
+				
+			}
+			if(m_aWeapons[m_ActiveWeapon].m_Ammo < 1 && m_Armor > 0)
+			{
+				m_aWeapons[m_ActiveWeapon].m_Ammo = 10;
+				m_Armor--;
+			}
+		}	
+		else
+		{
+			// reset weapon on turret leave 
+			if(m_PrevOnTurret)
+			{
+				m_TurretAmmo = m_aWeapons[WEAPON_GUN].m_Ammo;
+				m_aWeapons[WEAPON_GUN].m_Ammo = m_PrevTurretSwitchAmmo;
+				m_aWeapons[WEAPON_GUN].m_Got = m_PrevTurretSwitchGot;
+				SetWeapon(m_LastWeapon);
+				m_PrevOnTurret = 0;
+				m_TurretActive = 0;
+			}
+		}
+
+		// Reapinator 
+		if(m_OnReapinator)
+		{
+			if(!m_PrevOnReapinator && Server()->Tick() - m_ShowInfoTick > 0)
+			{
+				if(GameServer()->m_pController->ReapinatorOnline())
+					GameServer()->SendChatTarget(m_pPlayer->GetCID(),"Reapinator: Prototype restriction: Mutant required.");
+				else
+					GameServer()->SendChatTarget(m_pPlayer->GetCID(),"Reapinator: Warmup in progress. Please come again later.");
+				m_ShowInfoTick = Server()->Tick() + 2 * Server()->TickSpeed();
+			}
+		}
+		// Energynator
+		else if(m_OnEnergyUp)
+		{
+			if(Server()->Tick() - m_EnergyUpTick > 0)
+			{
+				if(GameServer()->m_pController->MutPowerSupply())
+				{
+					if(m_LaserWall)
+					{
+						GameServer()->SendChatTarget(m_pPlayer->GetCID(),"Deactivating laserwall for fillup.");
+						DestroyLaserWall();
+                                                GameServer()->CreateSound(m_Pos, SOUND_RIFLE_BOUNCE);
+					}
+
+					m_EnergyUpTick = Server()->Tick() + 200 * Server()->TickSpeed() / 1000;
+					if(m_Armor < 10)
+					{
+						GameServer()->CreateSound(m_Pos, SOUND_PICKUP_ARMOR);
+						IncreaseArmor(1);
+					}
+	
+					if(m_Health < 10)
+					{
+						GameServer()->CreateSound(m_Pos, SOUND_PICKUP_HEALTH);
+						IncreaseHealth(1);
+					}
+				}
+				else if(!m_PrevOnEnergyUp)
+				{
+					m_EnergyUpTick = Server()->Tick() + 4 * Server()->TickSpeed();
+					GameServer()->SendChatTarget(m_pPlayer->GetCID(),"Generator is down!");
+				}	
+			}
+		}
+
+		// show laser subtype as broadcast
+		if (m_LaserCycleInfoSwitch == 1 && Server()->Tick() - m_LaserCycleTick > 0)
+		{
+			m_LaserCycleInfoSwitch = 0;
+			if(m_ActiveWeapon == WEAPON_RIFLE)
+				GameServer()->SendBroadcast(CLaser::m_SubDescription[m_aWeapons[WEAPON_RIFLE].m_SubType], m_pPlayer->GetCID());
+				
+		}
+	}
+	else
+	{
+		// Reapinator
+		if(m_OnReapinator)
+		{
+			if(GameServer()->m_pController->ReapinatorOnline())
+			{
+				if(m_pPlayer->m_MutatorTeam == TEAM_MUTANT)
+				{
+					if(m_pPlayer->m_Score >= g_Config.m_SvReapinatorMinScore)
+					{
+						char aBuf[512];
+						str_format(aBuf,sizeof(aBuf),"Alica-KI: WARNING: %s metamorphosed and became an alien-reaper!",Server()->ClientName(m_pPlayer->GetCID()));
+						GameServer()->SendChatTarget(-1,aBuf);
+						BecameReaper();
+					}
+					else if(!m_PrevOnReapinator && Server()->Tick() - m_ShowInfoTick > 0)
+					{
+						GameServer()->SendChatTarget(m_pPlayer->GetCID(),"Reapinator: Too less score for metamorphose. Please come again later.");
+						m_ShowInfoTick = Server()->Tick() + 2 * Server()->TickSpeed();	
+					}	
+				}
+				else if(!m_PrevOnReapinator && Server()->Tick() - m_ShowInfoTick > 0)
+				{
+					if(g_Config.m_SvHappyMsgOn)
+					{
+						switch(rand()%5)
+						{
+							case 0: GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvHappyReapinatorA); break;
+							case 1: GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvHappyReapinatorB); break;
+							case 2: GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvHappyReapinatorC); break;
+							case 3:	GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvHappyReapinatorD); break;
+							case 4: GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvHappyReapinatorE); break;
+						}
+						m_ShowInfoTick = Server()->Tick() + 2 * Server()->TickSpeed();	
+					}
+				}
+			}
+			else if(!m_PrevOnReapinator && Server()->Tick() - m_ShowInfoTick > 0)
+			{
+				GameServer()->SendChatTarget(m_pPlayer->GetCID(),"Reapinator: Warmup in progress. Please come again later.");
+				m_ShowInfoTick = Server()->Tick() + 2 * Server()->TickSpeed();	
+			}
+		}
+		// Sceptic Energynator text 
+		else if(m_OnEnergyUp && GameServer()->m_pController->MutPowerSupply())
+		{
+			if(g_Config.m_SvScepticMsgOn && !m_PrevOnEnergyUp && Server()->Tick() - m_ShowInfoTick > 0)
+			{
+				switch(rand()%5)
+				{
+					case 0: GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvScepticEnergynatorA); break;
+					case 1: GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvScepticEnergynatorB); break;
+					case 2: GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvScepticEnergynatorC); break;
+					case 3:	GameServer()->SendChatTarget(m_pPlayer->GetCID(),g_Config.m_SvScepticEnergynatorD); break;
+					case 4: GameServer()->SendChatTarget(-1,g_Config.m_SvScepticEnergynatorE); break;
+				}
+				m_ShowInfoTick = Server()->Tick() + 2 * Server()->TickSpeed();	
+			}
+		}
+
+		// Mutantic emote (add random)
+		if(Server()->Tick() - m_MutanticEmoteTick > 0)
+		{
+			SetEmote(EMOTE_FLASHING, Server()->Tick() + 2000 * Server()->TickSpeed() / 1000);
+			m_MutanticEmoteTick = Server()->Tick() + (1000 * g_Config.m_SvMutEmoteDelay + (1000 * rand()%10)) * Server()->TickSpeed() / 1000;
+		}
+		
+		if((m_pPlayer->m_MutatorTeam == TEAM_REAPER || m_pPlayer->m_MutaticLevels&MUTATOR_SELFHEAL) && Server()->Tick() - m_AlienMetaTick > 0)
+		{
+			IncreaseHealth(1);
+			IncreaseArmor(1);
+			m_AlienMetaTick = Server()->Tick() + 2 * Server()->TickSpeed();
+		}
+
+		// Alien Multijump
+		if(m_pPlayer->m_MutatorTeam == TEAM_REAPER || m_pPlayer->m_MutaticLevels&MUTATOR_JUMP)
+		{
+			if(m_Core.m_Jumped&2 && m_Input.m_Jump && !m_PrevInput.m_Jump && m_LatestInput.m_Jump)
+			{
+				m_MutanticArmorDJCount++;
+				if(m_MutanticArmorDJCount < 5) 
+					m_Core.m_Jumped = 1;	
+				// skip on step to avoid decrease of shield by mistake
+				else if(m_MutanticArmorDJCount > 6 && m_Armor)
+				{
+					m_Core.m_Jumped = 1;	
+					GameServer()->CreateSound(m_Pos, SOUND_BODY_LAND);
+					m_Armor--;
+					if(m_MutanticArmorDJCount > 10)
+						SetEmote(EMOTE_FLASHING, Server()->Tick() + 2000 * Server()->TickSpeed() / 1000);
+				}
+			}
+			else if(m_MutanticArmorDJCount && IsGrounded()) 
+				m_MutanticArmorDJCount = 0;
+		}
+		else
+		{
+			if(m_Core.m_Jumped&2 && m_Input.m_Jump && !m_PrevInput.m_Jump && m_LatestInput.m_Jump)
+			{
+				m_MutanticArmorDJCount++;
+				if(m_MutanticArmorDJCount < 2)
+					m_Core.m_Jumped = 1;
+			}
+			else if(m_MutanticArmorDJCount && IsGrounded())
+			m_MutanticArmorDJCount = 0;
+		}
+	
+		// Alien Hook
+		if(m_pPlayer->m_MutaticLevels&MUTATOR_ENDLESSHOOK)
+			m_Core.m_HookTick = 0;
+	}
+
 	// Previnput
 	m_PrevInput = m_Input;
+	m_PrevOnTurret = m_OnTurret;	
+	m_PrevOnScience = m_OnScience;
+	m_PrevOnEnergyUp = m_OnEnergyUp;
+	m_PrevOnReapinator = m_OnReapinator;
 	return;
 }
 
